Added even more double-quoting.
[rsync/rsync.git] / testsuite / rsync.fns
1 #! /bin/sh
2
3 # Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5 # General-purpose test functions for rsync.
6
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License version
9 # 2 as published by the Free Software Foundation.
10 #
11 # This program is distributed in the hope that it will be useful, but
12 # WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
14 # Lesser General Public License for more details.
15
16 # You should have received a copy of the GNU Lesser General Public
17 # License along with this program; if not, write to the Free Software
18 # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
21 tmpdir="$scratchdir"
22 fromdir="$tmpdir/from"
23 todir="$tmpdir/to"
24 chkdir="$tmpdir/chk"
25
26 # Berkley's nice.
27 PATH="$PATH:/usr/ucb"
28
29 if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
30     diffopt="-u"
31 else
32     diffopt="-c"
33 fi
34
35 runtest() {
36     echo $ECHO_N "Test $1: $ECHO_C"
37     if eval "$2"
38     then
39         echo "$ECHO_T   done."
40         return 0
41     else
42         echo "$ECHO_T failed!"
43         return 1
44     fi
45 }
46
47 printmsg() {
48     echo "$1"
49 }
50
51
52 rsync_ls_lR() {
53     find "$@" -print | sort | xargs "$TOOLDIR/tls"
54 }
55
56 rsync_getgroups() { 
57     "$TOOLDIR/getgroups"
58 }
59
60
61 ####################
62 # Build test directories $todir and $fromdir, with $fromdir full of files.
63
64 hands_setup() {
65     # Clean before creation
66     rm -rf "$fromdir"
67     rm -rf "$todir"
68
69     [ -d "$tmpdir" ] || mkdir "$tmpdir"
70     [ -d "$fromdir" ] || mkdir "$fromdir"
71     [ -d "$todir" ] || mkdir "$todir"
72
73     # On some BSD systems, the umask affects the mode of created
74     # symlinks, even though the mode apparently has no effect on how
75     # the links behave in the future, and it cannot be changed using
76     # chmod!  rsync always sets its umask to 000 so that it can
77     # accurately recreate permissions, but this script is probably run
78     # with a different umask. 
79
80     # This causes a little problem that "ls -l" of the two will not be
81     # the same.  So, we need to set our umask before doing any creations.
82
83     # set up test data
84     touch "$fromdir/empty"
85     mkdir "$fromdir/emptydir"
86
87     # a hundred lines of text or so
88     rsync_ls_lR "$srcdir" > "$fromdir/filelist"
89
90     echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
91     umask 0
92     ln -s nolf "$fromdir/nolf-symlink"
93     umask 022
94
95     cat $srcdir/*.c > "$fromdir/text"
96     mkdir "$fromdir/dir"
97     cp "$fromdir/text" "$fromdir/dir"
98     mkdir "$fromdir/dir/subdir"
99     echo some data > "$fromdir/dir/subdir/foobar.baz"
100     mkdir "$fromdir/dir/subdir/subsubdir"
101     ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
102     mkdir "$fromdir/dir/subdir/subsubdir2"
103     ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
104
105 #      echo testing head:
106 #      ls -lR "$srcdir" | head -10 || echo failed
107 }
108
109
110 ####################
111 # Many machines do not have "mkdir -p", so we have to build up long paths.
112 # How boring.  
113 makepath () {
114     echo "        makepath $1"
115     p="$1"
116     (
117         # Absolut Unix.
118         if echo $p | grep '^/' >/dev/null
119         then
120             cd /
121         fi
122     
123         # This will break if $1 contains a space.
124         for c in `echo $p | tr '/' ' '`
125         do 
126             if [ -d "$c" ] || mkdir "$c" 
127             then
128                 cd "$c" || return $?
129             else
130                 echo "failed to create $c" >&2; return $?
131             fi
132         done
133     )
134 }
135
136
137
138 ###########################
139 # Run a test (in '$1') then compare directories $2 and $3 to see if
140 # there are any difference.  If there are, explain them.
141
142 # So normally basically $1 should be an rsync command, and $2 and $3
143 # the source and destination directories.  This is only good when you
144 # expect to transfer the whole directory exactly as is.  If some files
145 # should be excluded, you might need to use something else.
146
147 checkit() {
148     failed=
149
150     # We can just write everything to stdout/stderr, because the
151     # wrapper hides it unless there is a problem.
152
153     echo "Running: \"$1\""  
154     eval "$1" 
155     status=$?
156     if [ $status != 0 ]; then
157         failed="YES";
158     fi
159
160     echo "-------------"
161     echo "check how the files compare with diff:"
162     echo ""
163     for f in `cd "$2"; find . -type f -print `
164     do 
165         diff $diffopt "$2"/"$f" "$3"/"$f" || failed=YES
166     done
167
168     echo "-------------"
169     echo "check how the directory listings compare with diff:"
170     echo ""
171     ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
172     ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
173     diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
174     if [ -z "$failed" ] ; then
175         return 0
176     else
177         return 1
178     fi
179 }
180
181
182 build_rsyncd_conf() {
183     # Build an appropriate configuration file
184     conf="$scratchdir/test-rsyncd.conf"
185     echo "building configuration $conf"
186
187     port=2612
188     pidfile="$scratchdir/rsyncd.pid"
189     logfile="$scratchdir/rsyncd.log"
190
191     cat >"$conf" <<EOF
192 # rsyncd configuration file autogenerated by $0
193
194 pid file = $pidfile
195 use chroot = no
196 hosts allow = localhost, 127.0.0.1
197 log file = $logfile
198 exclude = foobar.baz
199 max verbosity = 9
200
201 uid = 0
202 gid = 0
203
204 [test-from]
205         path = $fromdir
206         read only = yes
207
208 [test-to]
209         path = $todir
210         read only = no
211 EOF
212 }
213
214
215 build_symlinks() {
216     mkdir "$fromdir"
217     date >"$fromdir/referent"
218     ln -s referent "$fromdir/relative"
219     ln -s "$fromdir/referent" "$fromdir/absolute"
220     ln -s nonexistent "$fromdir/dangling"
221     ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
222 }
223
224 test_fail() {
225     echo "$@" >&2
226     exit 1
227 }
228
229 test_skipped() {
230     echo "$@" >&2
231     echo "$@" > "$tmpdir/whyskipped"
232     exit 77
233 }
234
235 # It failed, but we expected that.  don't dump out error logs, 
236 # because most users won't want to see them.  But do leave
237 # the working directory around.
238 test_xfail() {
239     echo "$@" >&2
240     exit 78
241 }
242
243 # Determine what shell command will appropriately test for links.
244 ln -s foo "$scratchdir/testlink"
245 for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
246 do
247     for switch in -h -L
248     do
249         if $cmd $switch "$scratchdir/testlink" 2>/dev/null
250         then
251             # how nice
252             TEST_SYMLINK_CMD="$cmd $switch"
253             # i wonder if break 2 is portable?
254             break 2
255         fi
256    done
257 done
258 # ok, now get rid of it
259 rm "$scratchdir/testlink"
260
261
262 if [ "x$TEST_SYMLINK_CMD" = 'x' ]
263 then
264     test_fail "Couldn't determine how to test for symlinks"
265 else
266     echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
267 fi
268         
269
270 # Test whether something is a link, allowing for shell peculiarities
271 is_a_link() {
272     # note the variable contains the first option and therefore is not quoted
273     $TEST_SYMLINK_CMD "$1"
274 }
275
276
277 # We need to set the umask to be reproducible.  Note also that when we
278 # do some daemon tests as root, we will setuid() and therefore the
279 # directory has to be writable by the nobody user in some cases.  The
280 # best thing is probably to explicitly chmod those directories after
281 # creation.
282  
283 umask 022